#pragma check_stack(off)
#pragma comment(linker,"/OPT:NOWIN98")
#include <windows.h>
#include <string>

#define CCODE (char)3
#define CBOLD (char)2
#define CUL   (char)31
#define CREV  (char)22
#define CORIG (char)15

struct SPAN {
	char spanclass[6]; //sFFBB
	short backcolor;
	short forecolor;
	bool isBold;
	bool isUl;
	bool isRev;
	SPAN *next; //crude, memory efficient chain
};

unsigned long strcount(char*buf,char ch) {
	char*temp = buf;
	unsigned long count = 0;
	for (count = 0;(temp = strchr(temp,ch)); count++) temp++;
	return count;
}
char**strdelimlist(char *buf,unsigned long*lines, char ch) {
	unsigned long count = strcount(buf,ch) + 1, i;
	char* *list = new char*[count];
	char *temp = buf;
	*lines = count--;
	for (i = 0; i <= count; i++) {
		if (i != count) {
			temp = strchr(temp,ch);
			*temp = '\0';
			temp++;
		}
		list[i] = buf;
		buf = temp;
	}
	return list;
}


long __stdcall irc2html(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause) {
	//filename?outfile?fontname?fontsize?defaultfore?defaultback?rgb0?rgb1?rgb2?rgb3?rgb4?rgb5?rgb6?rgb7?rgb8?rgb9?rgb10?rgb11?rgb12?rgb13?rgb14?rgb15
	unsigned long numparams, numlines, i;
	char* *param = strdelimlist(data,&numparams,'?');
	char* *line;
	HANDLE hFile;
	DWORD fSize, bRead;
	char *filebuf, *curline, *temp, *tFname;
	char colors[16][7];
	SPAN spans,*curspan, *ispan;
	bool isSpan = false, isValid = true, isBold, isRev, isUl,isDone, isDigAfterComma, isLastCharSpace;
	short forecolor, backcolor, count;
	spans.next = NULL;
	hFile = CreateFile(param[0],GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,NULL,NULL);
	if (numparams != 22) isValid = false;
	else {
		for (i = 0; i < numparams; i++) {
			if (param[i][0] == '\0' && i != 3) { //can have blank fontsize
				isValid = false;
				break;
			}
		}
	}
	
	if (hFile == INVALID_HANDLE_VALUE) {
		//bad file
	}
	else if (!isValid) {
		strcpy(data,"E_INSUFFICIENT_PARAMETERS");
	}
	else {

		fSize = GetFileSize(hFile,NULL);
		filebuf = new char[fSize+1];
		ReadFile(hFile,filebuf,fSize,&bRead,NULL);
		filebuf[fSize] = '\0';
		CloseHandle(hFile);
		tFname = new char[strlen(param[0]) + 6];

		temp = strrchr(param[0],'\\');
		if (temp == NULL)
			temp = param[0] - 1;
		strcpy(tFname,param[0]);
		tFname[temp-param[0]+1]= '\0';
		strcat(strcat(strcat(tFname,"~"),temp+1),".tmp");
		
		//made it path\~filename.ext.tmp

		hFile = CreateFile(tFname,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,NULL,NULL);
		if (hFile == INVALID_HANDLE_VALUE) {
			delete[] tFname;
			strcpy(data,"E_COULDNT_OPEN_OUTFILE");
		}
		else {
			//put defaultfore and defaultback into short form, can use the same buffer
			//because it has to be at least one character, and the null. short is 2 bytes.
			//4 = fore        5 = back
			*(short*)(param[4]) = (short)(abs(atoi(param[4]) % 16));
			*(short*)(param[5]) = (short)(abs(atoi(param[5]) % 16));
			//puts the colors into hex
			for (i = 6; i < numparams; i++) {
				sprintf(colors[i-6],"%06X",atol(param[i]));
				//i know this wont overrun the null, because a base 16 number wont ever be
				//longer than a base 10 number.
				
				((unsigned short*)colors[i-6])[0] ^=
					((unsigned short*)colors[i-6])[2] ^=
					((unsigned short*)colors[i-6])[0] ^=
					((unsigned short*)colors[i-6])[2];
				//the decimal representation of an RGB, turned to hex gives you BGR, swapping
				//the blue and red
			}
			line = strdelimlist(filebuf,&numlines,'\n');
			for (i = 0; i < numlines; i++) {
				//defaults
				isLastCharSpace = isSpan = isRev = isUl = isBold = spans.isRev = spans.isUl = spans.isBold = false;
				forecolor = spans.forecolor = *(short*)(param[4]);
				backcolor = spans.backcolor = *(short*)(param[5]);
				for (curline = line[i];*curline;curline++) {
					
					switch (*curline) {
						case CCODE:
							temp = curline+1;
							isValid = false; // are there ANY valid settings?
							isDone = false; //is there a comma yet?
							isDigAfterComma = false;
							forecolor = 0;
							backcolor = 0;
							count = 0;
							while (temp <= curline+5) {
								if ( ((*temp >= '0') && (*temp <= '9')) ||		  //a number
									((isValid) && (!isDone) && (*temp == ',')) ) //first comma
								{
									isValid = true;
									if (*temp == ',') {
										if (temp > curline+3) break;
										isDone = true;
										count = 0;
									}
									else {
										if (count == 2) break;
										count++;
										if (!isDone)
											forecolor = forecolor * 10 + *temp - '0';
										else {
											isDigAfterComma = true;
											backcolor = backcolor * 10 + *temp - '0';
										}
									}
									temp++;
								}
								else break;
							}
							temp--;
							if (isDone && !isDigAfterComma) {
								temp--;
								backcolor = spans.backcolor;
							}
							curline = temp;

							if (!isValid || forecolor == 99)
								forecolor = *(short*)(param[4]);
							else
								forecolor %= 16;

							if (isValid && !isDone)
								backcolor = spans.backcolor;
							if (!isValid || backcolor == 99)
								backcolor = *(short*)(param[5]);
							else
								backcolor %= 16;
							break;
						case CORIG:
							//defaults
							isRev = isUl = isBold = false;
							forecolor = *(short*)(param[4]);
							backcolor = *(short*)(param[5]);
							break;
						case CBOLD:
							isBold = (isBold)?false:true;
							break;
						case CUL:
							isUl = (isUl)?false:true;
							break;
						case CREV:
							isRev = (isRev)?false:true;
							break;
						case '\r':
							break;
							
						default:
							if (isRev     != spans.isRev     ||
								isUl      != spans.isUl      ||
								isBold    != spans.isBold    ||
								forecolor != spans.forecolor ||
								backcolor != spans.backcolor)
							{
								//checking/adding/writing spans
								spans.isRev     = isRev;
								spans.isUl      = isUl;
								spans.isBold    = isBold;
								spans.forecolor = forecolor;
								spans.backcolor = backcolor;
								if (isRev)
									sprintf(spans.spanclass,"%d",0);
								else
									sprintf(spans.spanclass,"%d%d%02d",(isBold)+(isUl)*2+(isRev)*4,forecolor,backcolor);
								if (isSpan) //if there's an open span tag, close it.
									WriteFile(hFile,"</span>",7,&bRead,NULL);
								isSpan = true;
								WriteFile(hFile,"<span class=",12,&bRead,NULL);
								WriteFile(hFile,spans.spanclass,strlen(spans.spanclass),&bRead,NULL);
								WriteFile(hFile,">",1,&bRead,NULL);
								curspan = &spans;
								isValid = false; //is there a match?
								while ((ispan = curspan->next) != NULL) {
									if (strcmp(spans.spanclass,ispan->spanclass) == 0) {
										isValid = true;
										break;
									}
									curspan = ispan;
								}
								if (!isValid) { //need to add it
									curspan->next = new SPAN;
									ispan = curspan->next;
									strcpy(ispan->spanclass,spans.spanclass);
									ispan->backcolor = backcolor;
									ispan->forecolor = forecolor;
									ispan->isBold    = isBold;
									ispan->isRev     = isRev;
									ispan->isUl      = isUl;
									ispan->next      = NULL;
								}
							}
							if (*curline == ' ') {
								if (isLastCharSpace)
									WriteFile(hFile,"&nbsp;",6,&bRead,NULL);
								else
									WriteFile(hFile,curline,1,&bRead,NULL);
								isLastCharSpace = true;
							}
							else {
								isLastCharSpace = false;
								if (*curline == '<')      WriteFile(hFile,"&lt;",4,&bRead,NULL);
								else if (*curline == '>') WriteFile(hFile,"&gt;",4,&bRead,NULL);
								else if (*curline == '&') WriteFile(hFile,"&amp;",5,&bRead,NULL);
								else WriteFile(hFile,curline,1,&bRead,NULL);
							}
					} //end of switch
				}
				if (isSpan)
					WriteFile(hFile,"</span>",7,&bRead,NULL);
				if (i != numlines-1)
					WriteFile(hFile,"<br>",4,&bRead,NULL);		////////////
			}
			CloseHandle(hFile);
			delete[] filebuf;
			delete[] line;
			//read the output into a buffer
			hFile = CreateFile(tFname,GENERIC_READ,0,NULL,OPEN_EXISTING,NULL,NULL); //why check these, i just wrote them.
			fSize = GetFileSize(hFile,NULL);
			filebuf = new char[fSize+1];
			ReadFile(hFile,filebuf,fSize,&bRead,NULL);
			filebuf[fSize] = '\0';
			CloseHandle(hFile);
			//insert the header information before it
			hFile = CreateFile(tFname,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,NULL,NULL);
			WriteFile(hFile,"<html><head><title>irc2html</title><style type=\"text/css\"><!--\r\n",64,&bRead,NULL);
			
			curspan = &spans;
			ispan = curspan->next;
			while (ispan != NULL) {
				WriteFile(hFile,".",1,&bRead,NULL);	
				WriteFile(hFile,ispan->spanclass,strlen(ispan->spanclass),&bRead,NULL);
				WriteFile(hFile,"{font-weight:",13,&bRead,NULL);
				if (ispan->isBold) {
					WriteFile(hFile,"bold;text-decoration:",21,&bRead,NULL);
				}
				else {
					WriteFile(hFile,"normal;text-decoration:",23,&bRead,NULL);
				}
				if (ispan->isUl) {
					WriteFile(hFile,"underline;color:",16,&bRead,NULL);
				}
				else {
					WriteFile(hFile,"none;color:",11,&bRead,NULL);
				}
				if (ispan->isRev) {
					WriteFile(hFile,colors[*(short*)(param[5])],6,&bRead,NULL); //def bg color
					WriteFile(hFile,";background-color:",18,&bRead,NULL);
					WriteFile(hFile,colors[*(short*)(param[4])],6,&bRead,NULL); //def fg color
				}
				else {
					WriteFile(hFile,colors[ispan->forecolor],6,&bRead,NULL);
					WriteFile(hFile,";background-color:",18,&bRead,NULL);
					WriteFile(hFile,colors[ispan->backcolor],6,&bRead,NULL);
				}
				WriteFile(hFile,";}\r\n",4,&bRead,NULL);
				curspan = ispan->next; //temp
				delete ispan;
				ispan = curspan;
			}
			
			WriteFile(hFile,"body{font-family:",17,&bRead,NULL);
			WriteFile(hFile,param[2],strlen(param[2]),&bRead,NULL);
			if (param[3][0] != '\0') {
				WriteFile(hFile,";font-size:",11,&bRead,NULL);
				WriteFile(hFile,param[3],strlen(param[3]),&bRead,NULL);
			}
			WriteFile(hFile,";color:",7,&bRead,NULL);
			WriteFile(hFile,colors[*(short*)(param[4])],6,&bRead,NULL);
			WriteFile(hFile,";background-color:",18,&bRead,NULL);
			WriteFile(hFile,colors[*(short*)(param[5])],6,&bRead,NULL);
			WriteFile(hFile,";}\r\n",4,&bRead,NULL);
			WriteFile(hFile,"--></style></head><body>\r\n",26,&bRead,NULL);
			WriteFile(hFile,filebuf,fSize,&bRead,NULL);
			CloseHandle(hFile);
			remove(param[1]);
			rename(tFname,param[1]);
			strcpy(data,"S_OK");
			delete[] tFname;
		}
		delete[] filebuf;
	}
	
	delete[] param;
	return 3;
	
}
